stages:
  - release

release:
  stage: release
  only:
    - schedules
  image: node:14-alpine
  before_script:
    - apk add --update curl jq
    - apk add --update openssh-client git
  script:
    - eval $(ssh-agent -s)
    - echo "$DEPLOY_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - git config user.email "gitlab-runner@gitlab.com"
    - git config user.name "Gitlab Runner"
    - export CI_PUSH_REPO=$(echo "$CI_REPOSITORY_URL" | sed -e "s|.*@\(.*\)|git@\1|" -e "s|/|:/|" )
    - git remote set-url --push origin "ssh://${CI_PUSH_REPO}"
    - git reset --hard
    - git clean -fd
    - git checkout dev
    - git pull origin dev
    - npx standard-version --no-verify
    - git push --follow-tags origin dev
  after_script:
    - eval $(ssh-agent -s)
    - echo "$DEPLOY_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'
    - git config user.email "gitlab-runner@gitlab.com"
    - git config user.name "Gitlab Runner"
    - export CI_PUSH_REPO=$(echo "$CI_REPOSITORY_URL" | sed -e "s|.*@\(.*\)|git@\1|" -e "s|/|:/|" )
    - git remote set-url --push origin "ssh://${CI_PUSH_REPO}"
    - git checkout dev
    - git pull origin dev
    - git checkout main
    - git pull origin main
    - git merge dev
    - 'git commit --amend -m "chore: merge branch dev into main"'
    - git push origin main
    - PACKAGE_VERSION=$(cat package.json | grep version | head -1 | awk -F= "{ print $2 }" | sed 's/[version:,\",]//g' | tr -d '[[:space:]]')
    - echo $PACKAGE_VERSION
    - VERSION_BADGE_ID=$(curl --header "PRIVATE-TOKEN:${GITLAB_API_TOKEN}" https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/badges | jq -c 'map(select(.name | contains("version")))[0].id')
    - echo $VERSION_BADGE_ID
    - curl --request PUT --header "PRIVATE-TOKEN:${GITLAB_API_TOKEN}" --data "image_url=https://img.shields.io/badge/version-${PACKAGE_VERSION}-blue" https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/badges/${VERSION_BADGE_ID}
